#ifndef SMOLYAKINDEX_H
#define SMOLYAKINDEX_H 1

#include <vector>
#include <iostream>

class SmolyakIndex{

public:
	std::vector<int> index;     // Current index vector 
    int k;                      // Maximum l_1 norm of the index 
	int dim;                    // Dimension of the index
	int sum;                    // The l_1 norm of the current index (i.e. the sum
	                            //  of its components)
	bool is_done;               // Have we reached the last index?
	
	
	
	// Constructor (initializes the above variables) 
    SmolyakIndex(const int k, const int d);
	
	// Sets the current index to the next valid index
    void next();
	
	// Indicates whether all valid indices have been looked at
    bool done();

};

// This allows the pretty output of a two-dimensional index
std::ostream& operator<<(std::ostream& Stream, const SmolyakIndex& b){
	Stream << "{";
	for(int i = 0; i < b.dim - 1; ++i){
		Stream << b.index[i] << ",";
	}
	if(b.dim > 0){
		Stream << b.index[b.dim-1];
	}
	Stream << "}";
	return Stream;
} 

#endif // SMOLYAKINDEX_H